import math;
import hyperbolic_geometry;

size(500,500);
settings.outformat="pdf";

// What do we want to test?
// The calculation of mirrors from given points.

hyperbolic_point O = hyperbolic_point(0,0);
dot(O,red);

hyperbolic_point P = hyperbolic_point(0.8,20);
hyperbolic_circle C = hyperbolic_circle(O, P);
draw(C, gray+opacity(0.3));

hyperbolic_polygon W = hyperbolic_regular_ngon(O, P, 5);
fill(W, blue+opacity(0.2));
draw(W);
dot(W);

hyperbolic_point[] EP = W.get_corners();
hyperbolic_segment[] side = W.get_sides();

for (int i = 0; i <= 4; ++i) {
    string s = string(side[i].length(), 4);
    label(s,(side[i].get_first_point().get_euclidean()+side[i].get_second_point().get_euclidean())/2);
}

for (int i = 0; i <= 4; ++i) {
    string s = string(angle(EP[(i)%5], EP[(i+1)%5], EP[(i+2)%5]), 4);
    label(s,EP[(i+1)%5].get_euclidean());
}

//---------------------

hyperbolic_point O = hyperbolic_point(2,60);
dot(O,red);

hyperbolic_point P = hyperbolic_point(3,70);
C = hyperbolic_circle(O, P);
draw(C, gray+opacity(0.3));

hyperbolic_polygon W = hyperbolic_regular_ngon(O, P, 5);
fill(W, green+opacity(0.5));
draw(W);
dot(W);

hyperbolic_point[] EP = W.get_corners();
hyperbolic_segment[] side = W.get_sides();

for (int i = 0; i <= 4; ++i) {
    string s = string(side[i].length(), 4);
    label(s,(side[i].get_first_point().get_euclidean()+side[i].get_second_point().get_euclidean())/2);
}

for (int i = 0; i <= 4; ++i) {
    string s = string(angle(EP[(i)%5], EP[(i+1)%5], EP[(i+2)%5]), 4);
    label(s,EP[(i+1)%5].get_euclidean());
}

//---------------------

hyperbolic_point O = hyperbolic_point(2,260);
dot(O,red);

hyperbolic_point P = hyperbolic_point(2,280);
C = hyperbolic_circle(O, P);
draw(C, gray+opacity(0.3));

hyperbolic_polygon W = hyperbolic_regular_ngon(O, P, 7);
fill(W, red+opacity(0.5));
draw(W);
dot(W);

hyperbolic_point[] EP = W.get_corners();
hyperbolic_segment[] side = W.get_sides();

for (int i = 0; i <= 6; ++i) {
    string s = string(side[i].length(), 4);
    label(s,(side[i].get_first_point().get_euclidean()+side[i].get_second_point().get_euclidean())/2);
}

for (int i = 0; i <= 6; ++i) {
    string s = string(angle(EP[(i)%7], EP[(i+1)%7], EP[(i+2)%7]), 4);
    label(s,EP[(i+1)%7].get_euclidean());
}

//---------------------

hyperbolic_point O = hyperbolic_point(2,180);
dot(O,red);
hyperbolic_point P = hyperbolic_point(1.5,180);
C = hyperbolic_circle(O, P);
draw(C, gray+opacity(0.3));

hyperbolic_polygon W = hyperbolic_regular_ngon(O, P, 4);
fill(W, yellow+opacity(0.6));
draw(W);
dot(W);

hyperbolic_point[] EP = W.get_corners();
hyperbolic_segment[] side = W.get_sides();

for (int i = 0; i <= 3; ++i) {
    string s = string(side[i].length(), 4);
    label(s,(side[i].get_first_point().get_euclidean()+side[i].get_second_point().get_euclidean())/2);
}

for (int i = 0; i <= 3; ++i) {
    string s = string(angle(EP[(i)%4], EP[(i+1)%4], EP[(i+2)%4]), 4);
    label(s,EP[(i+1)%4].get_euclidean());
}

draw((1,1)--(1,-1)--(-1,-1)--(-1,1)--cycle);
draw(unitcircle);
